/*------------------------------------------------------------
   Texel	(www.texel.fr.fm)		2001
   DirectInput8
   La souris
  ------------------------------------------------------------*/

#define INITGUID
#include <windows.h>
#include <stdio.h>
#include<dinput.h>

#pragma comment( lib, "dinput8.lib" )		// pour linker les librairies		

// initialisation de la position de la balle
int ballx=300;
int bally=220;

LPDIRECTINPUT8 lpDI;	// objet DirectInput
LPDIRECTINPUTDEVICE8 pMouse;	// pour la souris
DIPROPDWORD dipdw={
					{
						sizeof(DIPROPDWORD),
						sizeof(DIPROPHEADER),
						0,
						DIPH_DEVICE,
					},
					32
};
DIDEVICEOBJECTDATA data;


BOOL                    g_bActive       = TRUE;

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;


/******** acquisition de la souris si fentre active	*********/
HRESULT SetAcquire()
{
    // Aucune souris cre 
    if( NULL == pMouse )
        return S_FALSE;

    if( g_bActive ) 
        pMouse->Acquire();	// La fentre est active
    else 
        pMouse->Unacquire();	// La fentre est inactive

    return S_OK;
}

/********************* libration des objets *****************/
void Cleanup()
{
	// souris
	pMouse->Unacquire();
	pMouse->Release();
	pMouse=NULL;

	// objet Dinput
	lpDI->Release();
}

/****************** Initialisation de DirectInput **********************/
BOOL DInput_init(HINSTANCE hInstance,HWND hwnd){
	// creation de l'objet DirectInput
	if (DirectInput8Create(hInstance, DIRECTINPUT_VERSION, IID_IDirectInput8,(void**) &lpDI, NULL)!=DI_OK)
		return FALSE;
	// creation d'un objet DirectInputDevice
	if (lpDI->CreateDevice(GUID_SysMouse, &pMouse, NULL)!=DI_OK)
		return FALSE;
	// dfinition du format de donn
	if (pMouse->SetDataFormat(&c_dfDIMouse)!=DI_OK)
		return FALSE;
	// dfinition du niveau de coopration
	if( pMouse->SetCooperativeLevel(hwnd, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND)!=DI_OK)
		return FALSE;
	// cration d'un venement
	HANDLE hevtMouse=CreateEvent(0,0,0,0);
	if( pMouse->SetEventNotification(hevtMouse)!=DI_OK)
		return FALSE;
	// on passe la taille du tampon 
	if( pMouse->SetProperty(DIPROP_BUFFERSIZE,&dipdw.diph)!=DI_OK)
		return FALSE;
	// acquisition de la souris
	if( pMouse->Acquire()!=DI_OK)
		return FALSE;

	

	return TRUE;
}






/************* mais  jours la position de la ball **************/
void UpDateMouse(HWND hwnd){
	
	BOOL bDone=FALSE;
	DWORD dwNumElements=1;
	memset(&data,0,sizeof(DIDEVICEOBJECTDATA));
	while(!bDone)
	{	// On peut perdre la souris. On refait alors l'acquisition
		if(pMouse->GetDeviceData(sizeof(DIDEVICEOBJECTDATA),&data,
								 &dwNumElements,0)==DIERR_INPUTLOST)
		{
			if(pMouse->Acquire()==DI_OK)
				pMouse->GetDeviceData(sizeof(DIDEVICEOBJECTDATA),&data,
								 &dwNumElements,0);
		}
		switch(data.dwOfs){

		case DIMOFS_X:
			ballx+=data.dwData;
			break;
		case DIMOFS_Y:
			bally+=data.dwData;
			break;
		case DIMOFS_BUTTON0 :
			if(data.dwData & 0x80){
				bally+=100;
				dwNumElements=0;
			}
		
			break;


		}		
	
		if (ballx<0)	ballx=0;
		if (ballx>600)	ballx=600;
		if (bally<0)	bally=0;
		if (bally>420)	bally=420;
		
		if(dwNumElements==0)
			bDone=TRUE;
	}

	
	InvalidateRect(hwnd,NULL,TRUE);	
}

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
     static CHAR szAppName[] ="Salut" ;
     HWND         hwnd ;
     MSG          msg ;
     WNDCLASS     wndclass ;

	 

	 wndclass.style         = NULL;
     wndclass.lpfnWndProc   = WndProc ;
     wndclass.cbClsExtra    = 0 ;
     wndclass.cbWndExtra    = 0 ;
     wndclass.hInstance     = hInstance ;
     wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
     wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
     wndclass.hbrBackground = (HBRUSH) GetStockObject (BLACK_BRUSH) ;
     wndclass.lpszMenuName  = NULL ;
     wndclass.lpszClassName = szAppName ;

     if (!RegisterClass (&wndclass))
     {
          MessageBox (NULL, TEXT ("Problme!"),szAppName, MB_ICONERROR) ;
          return 0 ;
     }
     hwnd = CreateWindow (szAppName,                  // nom de la classe
                          "Texel - DirectInput8: La souris",		  // titre de la fentre
                           WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU
									| WS_MINIMIZEBOX | WS_VISIBLE ,   // style de la fentre
                          CW_USEDEFAULT,              // position initiale en x
                          CW_USEDEFAULT,              // position initiale en y
                          640,						  // largeur initiale
                          480,						  // hauteur initiale
                          NULL,                       // handle de la fentre mre
                          NULL,                       // handle du menu de la fentre
                          hInstance,                  // handle de l'instance
                          NULL) ;                     // paramtres de cration
     
     ShowWindow (hwnd, iCmdShow) ;
     UpdateWindow (hwnd) ;

	 if(DInput_init(hInstance,hwnd)==FALSE){
		 Cleanup();
	 }

	// dclaration et initialisation des constante pour le compteur
	DWORD temps_maintenant;      // temps courant
	DWORD  temps_fps=16;			// ms par image
	DWORD temps_suivant=0;		// temps pour rendre la prochane image
	DWORD temps_precedent=0;	    // temps de l'image prcdente image
	double temps_ecoule;			// temps coul depuis le dernier rendu
	double temps_echelle=0.05;		// chelle pour pouvoir utiliser une valeur entire pour speed

	// on sauvegarde l'heure maintenant dans suivant pour que temps_maintenant soit < que temps_suivant
	temps_suivant=GetTickCount();
	
	// sauvegarde du temps de la dernire frame
	temps_precedent=temps_suivant;


     while (1) { 
	
		if (PeekMessage( &msg, NULL, 0, 0, PM_REMOVE)) { 
			if (msg.message==WM_QUIT)	// pour quitter la boucle
				break; 
			TranslateMessage(&msg);
			DispatchMessage(&msg); 
		} else {		// aucain message!
		
			temps_maintenant=GetTickCount();		// quelle heure est-il ?
	
			// Si il est temps d'afficher la nouvelle frame 
			if (temps_maintenant>temps_suivant) { 
				temps_ecoule=(temps_maintenant-temps_precedent)*temps_echelle;
				temps_precedent=temps_maintenant;	// pour le prochain passage dans la boucle
				
			
				if(g_bActive == TRUE)
				UpDateMouse(hwnd);					// on calcule les nouvelles coordonnes de la balle
				
				temps_suivant = temps_maintenant + temps_fps; // pour la prochain passage de la boucle
			}		
		}
	 }

     return msg.wParam ;
}


/******************************** procdure de fentre ***********************/
LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP hbitmap;		// pour le bitmap

     switch (message)
     {

	 case WM_CREATE:
		 // on charge le bitmap une seule fois
		 hbitmap=(HBITMAP) LoadImage(NULL,"image.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
		 break;


   	 case WM_KEYDOWN:
		 switch(wParam)
		 {
			 
			case VK_ESCAPE:		// touche chape pour quitter
				DestroyWindow(hwnd);
				break;
			default:
				break;
			
		 }
		 break;

	  case WM_ACTIVATE:
		if (WA_INACTIVE == wParam)
			g_bActive = FALSE;
		else
			g_bActive = TRUE;

		
		SetAcquire();
		return 0; 



	case WM_PAINT:	// on affiche l'image au coordonnes dja calcules
				HDC hdc;HDC hdcMemory;
				PAINTSTRUCT ps;
				hdc=BeginPaint(hwnd,&ps);	// obtient un handle de contexte de priphrique
			    
				static BITMAP bm;
				hdcMemory=CreateCompatibleDC(NULL); 
				SelectObject(hdcMemory,hbitmap);
				GetObject(hbitmap,sizeof(bm),&bm); 
				BitBlt(hdc,ballx,bally,bm.bmWidth,bm.bmHeight,hdcMemory,0,0,SRCCOPY);				
		
				DeleteDC(hdcMemory);
				EndPaint(hwnd,&ps); 	// libre un handle de contexte de priphrique
				break;

     case WM_DESTROY:
		  DeleteObject(hbitmap);
		  Cleanup();		// ne surtout pas l'oublier
          PostQuitMessage (0) ;
          return 0 ;
	
    }
    return DefWindowProc (hwnd, message, wParam, lParam);

}
